'use strict';
const fetch = require('node-fetch');
const Axios = require("axios")
const validator = require("validator")


class McApi {

    /**
     * @param {string} username - The username to look for.
     * @returns {Promise<unknown>}
     */
    static getUUID(username) {
        console.log("1 " + username)
       


        let uuid = null;
        if(validator.isUUID(username)) {
            let mcData = ( Axios.get("https://sessionserver.mojang.com/session/minecraft/profile/" + username)).data
            uuid = mcData.id ? mcData.id.substr(0,8)+"-"+mcData.id.substr(8,4)+"-"+mcData.id.substr(12,4)+"-"+mcData.id.substr(16,4)+"-"+mcData.id.substr(20) : null   
            
        } else {
            let mcData = ( Axios.get("https://api.mojang.com/users/profiles/minecraft/" + username)).data
            uuid = mcData.id ? mcData.id.substr(0,8)+"-"+mcData.id.substr(8,4)+"-"+mcData.id.substr(12,4)+"-"+mcData.id.substr(16,4)+"-"+mcData.id.substr(20) : null   
            
        }
        return uuid
    }
    /**
     * @param {string} uuid - The username to look for.
     * @returns {Promise<unknown>}
     */
    static getUserName(uuid) {
        let mcData = ( Axios.get("https://sessionserver.mojang.com/session/minecraft/profile/" + uuid)).data
        console.log(mcData.name)
        return mcData.name;
    }
    /**
     * @param {string} uuid - The username to look for.
     * @returns {Promise<unknown>}
     */

    static getNameHistory(uuid) {
        //I use labymod api to get NameHisstory because, mojang have removed there nameHistory.
        const request = fetch(`https://laby.net/api/user/${uuid}/get-names`, {
            headers: {
              'User-Agent': uuid
            }
        })
        .then(res => res.text());
        let data = JSON.parse( request );
        
        var response = []
        for (let i = 0;i < data.length ;i++) {
            response.push(data[i].name)
        }
        
        return response

        

    }
    /**
     * @param {string} uuid - The username to look for.
     * @returns {Promise<unknown>}
     */
    static getPlayerSkin(uuid) {
        return `https://minotar.net/body/${uuid}/100.png`;
    }
    /**
     * @param {string} server - The username to look for.
     * @returns {Promise<unknown>}
     */
    static getServerStatus(server) {
       
        let serverData = (Axios.get("https://eu.mc-api.net/v3/server/ping/" + server)).data
        console.log(serverData.online)
        return serverData
      
    }   


    
}
